import 'package:flutter/material.dart';
import 'package:nova_utils/update/update_dialog.dart';
import 'package:nova_utils/update/update_utils.dart';
import 'package:package_info/package_info.dart';

import 'android_update_config.dart';

class AndroidUpdateDelegate extends UpdateCase {
  static AndroidUpdateConfig config;

  @override
  Future checkUpdate(BuildContext context) async {
    PackageInfo packageInfo = await PackageInfo.fromPlatform();
    config =  await getUpdateConfig();
    int updateVersionCode = config.updateVersionCode;
    int currentVersion = int.parse(packageInfo.buildNumber);
    if(updateVersionCode!=null){
      if(currentVersion < updateVersionCode){
        //这里存入versionName
        bool isSkip =  await UpdateUtils.isInSkipList(config.updateVersionName);
        //如果不在跳过名单中，并且不属于强制升级
        if(!isSkip || config.forceUpdate){
          UpdateDialogUtils.showAndroidDialog(context,config);
        }
      }
    }
  }

  static Future<AndroidUpdateConfig> getUpdateConfig()  async{
    if (config == null) {
      AndroidUpdateConfig data = new AndroidUpdateConfig();
      config =  await data.initConfig();
    }
    return config;
  }
}
