import 'package:nova_utils/kv_utils.dart';
import 'package:package_info/package_info.dart';

class AndroidUpdateConfig {
  String titleMessage;
  int updateVersionMin;
  String updateVersionName;
  int updateVersionCode;
  String releaseNote;
  String downlandUrl;
  String apkSize;
  int dialogStyle = 1;
  bool needDownland;
  bool forceUpdate = false;
  AndroidUpdateConfig();
  Future<AndroidUpdateConfig> initConfig() async {
    var instance = OnlineConfigUtils.getInstance();
    this.titleMessage =
        await instance.getConfigParams("update_title_normal_android");
    var update_version_min_android =
        await instance.getConfigParams("update_version_min_android");
    if (update_version_min_android.isNotEmpty) {
      this.updateVersionMin = int.parse(update_version_min_android);
    }
    this.updateVersionName =
        await instance.getConfigParams("update_version_name_android");
    var versionCode =
        await instance.getConfigParams("update_version_code_android");
    if (versionCode.isNotEmpty) {
      this.updateVersionCode = int.parse(versionCode);
    }
    this.releaseNote =
        await instance.getConfigParams("update_version_log_android");
    this.downlandUrl =
        await instance.getConfigParams("update_apk_file_url_android");
    this.apkSize =
        await instance.getConfigParams("update_apk_file_size_android");
    var style = await instance.getConfigParams("update_style_android");
    if (style.isNotEmpty) {
      this.dialogStyle = int.parse(style);
    }
    var needUpdate = await instance.getConfigParams("update_download_android");
    if (needUpdate.isNotEmpty) {
      this.needDownland == "true" ? true : false;
    }
    PackageInfo packageInfo = await PackageInfo.fromPlatform();
    if (int.parse(packageInfo.buildNumber) < this.updateVersionMin) {
        this.forceUpdate = true;
    }
    return this;
  }
}
